/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.definition.activity;

import java.util.Map;

import org.ow2.orchestra.definition.element.CorrelationSet;
import org.ow2.orchestra.definition.element.PartnerLink;
import org.ow2.orchestra.definition.element.Variable;
import org.ow2.orchestra.parsing.binding.exception.CorrelationSetNotFoundException;
import org.ow2.orchestra.pvm.model.Node;
import org.ow2.orchestra.runtime.BpelExecution;

/**
 * @author Guillaume Porcher
 *
 */
public interface IScope extends IAbstractBpelActivity {

  void executeMainActivity(final BpelExecution execution);

  CorrelationSet findCorrelationSet(final String correlationSetName) throws CorrelationSetNotFoundException;

  PartnerLink findPartnerLink(final String partnerLinkName);

  Variable findVariable(final String variableName);

  Variable getVariable(String variableName);

  Map<String, Variable> getVariables();

  Map<String, PartnerLink> getPartnerLinks();

  Map<String, CorrelationSet> getCorrelationSets();

  Node getScopeNode();

}
