/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.jmx.commands;

import org.ow2.orchestra.deployment.Deployer;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;
import org.ow2.orchestra.pvm.env.Environment;
import org.ow2.orchestra.pvm.internal.cmd.Command;

public final class UndeployCommand implements Command<Boolean> {

  private static final long serialVersionUID = -8060049777110201634L;

  private final ProcessDefinitionUUID pduuid;
  /**
   * @param pduuid
   */
  public UndeployCommand(final ProcessDefinitionUUID pduuid) {
    this.pduuid = pduuid;
  }

  public Boolean execute(final Environment environment) {
    final Deployer deployer = new Deployer();
    deployer.undeploy(this.pduuid, environment);
    return Boolean.TRUE;
  }
}
